*****************************************************************
      SUBROUTINE USER
*****************************************************************
      DOUBLE PRECISION TITLE
      LOGICAL LSOLVE,LPRINT,LBLK,LSTOP
      COMMON F(22,22,10),P(22,22),RHO(22,22),GAM(22,22),CON(22,22),
     &  AIP(22,22),AIM(22,22),AJP(22,22),AJM(22,22),AP(22,22),
     &  X(22),XU(22),XDIF(22),XCV(22),XCVS(22),
     &  Y(22),YV(22),YDIF(22),YCV(22),YCVS(22),
     &  YCVR(22),YCVRS(22),ARX(22),ARXJ(22),ARXJP(22),
     &  R(22),RMN(22),SX(22),SXMN(22),XCVI(22),XCVIP(22)
      COMMON DU(22,22),DV(22,22),FV(22),FVP(22),
     & FX(22),FXM(22),FY(22),FYM(22),PT(22),QT(22)
      COMMON /INDX/NF,NFMAX,NP,NRHO,NGAM,L1,L2,L3,M1,M2,M3,
     &  IST,JST,ITER,LAST,TITLE(13),RELAX(13),TIME,DT,XL,YL,
     &  IPREF,JPREF,LSOLVE(10),LPRINT(13),LBLK(10),MODE,NTIMES(10),RHOCO
     &N
      COMMON /CNTL/LSTOP
      COMMON /SORC/SMAX,SSUM
      COMMON /COEF/FLOW,DIFF,ACOF
      DIMENSION U(22,22),V(22,22),PC(22,22)
      EQUIVALENCE (F(1,1,1),U(1,1)),(F(1,1,2),V(1,1)),(F(1,1,3),PC(1,1))
      DIMENSION TH(22),THU(22),THDIF(22),THCV(22),THCVS(22)
      EQUIVALENCE(X,TH),(XU,THU),(XDIF,THDIF),(XCV,THCV)
     &  ,(XCVS,THCVS),(XL,THL)
*****************************************************************
*
*----------------- EXAMPLE FOUR  ----------------------------
*
*****************************************************************
*
      ENTRY GRID
      LSOLVE(4)=.TRUE.
      LPRINT(4)=.TRUE.
      LPRINT(5)=.TRUE.
      TITLE(4)='.W/WBAR.'
      TITLE(5)='.THETA.'
      NTIMES(4)=4
      NTIMES(5)=4
      LAST=6

      MODE=3
      PI=3.14159
      THL=15.*PI/180.
      YL=1.
      R(1)=1.
      L1=7
      M1=7
      CALL UGRID
      RETURN
*
      ENTRY START
      TW=1.
      DO 100 J=1,M1
      DO 100 I=1,L1
      F(I,J,4)=0.
      F(I,J,5)=TW
  100 CONTINUE
      AMU=1.
      DPDZ=-2000.
      RHOCP=1.
      COND=1.
      DTDZ=100.
      RETURN
*
      ENTRY DENSE
      RETURN
*
      ENTRY BOUND
      ASUM=0.
      WSUM=0.
      TSUM=0.
      DO 300 J=2,M2
      DO 300 I=2,L2
      IF(I.EQ.2.AND.J.LE.4) GOTO 300
      AR=YCVR(J)*THCV(I)
      WSUM=WSUM+F(I,J,4)*AR
      TSUM=TSUM+AR*F(I,J,4)*F(I,J,5)
      ASUM=ASUM+AR
  300 CONTINUE
      WBAR=WSUM/ASUM
      WP=(R(1)+R(M1))*THL+(1.+THCV(2))*(RMN(5)-R(1))
      DH=4.*ASUM/WP
      RE=RHOCON*WBAR*DH/AMU
      FRE=-2.*DPDZ*DH/(RHOCON*WBAR**2+1.E-30)*RE
      TBULK=TSUM/(WSUM+1.E-30)
      HTP=WP-R(M1)*THL
      HTC=RHOCP*WSUM*DTDZ/((TW-TBULK+1.E-30)*HTP)
      ANU=HTC*DH/COND
      IF(ITER.LT.3) RETURN
      LSOLVE(5)=.TRUE.
      LSOLVE(4)=.FALSE.
      RETURN

*
      ENTRY OUTPUT
      IF(ITER.NE.0) GOTO 400
      WRITE(8,401)
  401 FORMAT(1X,' ITER',12X,'F.RE',17X,'NU')
  400 WRITE(8,402) ITER,FRE,ANU
  402 FORMAT(1X,I6,1P2E20.4)
      IF(ITER.NE.LAST) RETURN
      DO 410 J=1,M1
      DO 410 I=1,L1
      F(I,J,4)=F(I,J,4)/WBAR
  410 F(I,J,5)=(F(I,J,5)-TW)/(TBULK-TW+1.E-30)
      CALL PRINT
      RETURN
*
      ENTRY GAMSOR
      DO 500 I=1,L1
      DO 500 J=1,M1
      GAM(I,J)=AMU
      IF(NF.NE.5) GAM(I,J)=COND
      GAM(1,J)=0.
      GAM(L1,J)=0.
      IF(NF.EQ.5) GAM(I,M1)=0.
      IF(J.LE.4) GAM(2,J)=1.E10
      IF(NF.EQ.5.AND.J.LE.4) GAM(2,J)=10.*COND
  500 CONTINUE
      DO 510 J=2,M2
      DO 510 I=2,L2
      CON(I,J)=-DPDZ
      IF(NF.EQ.5) CON(I,J)=-DTDZ*F(I,J,4)*RHOCP
  510 CONTINUE
      RETURN
      END
