*****************************************************************
      SUBROUTINE USER
*****************************************************************
      DOUBLE PRECISION TITLE
      LOGICAL LSOLVE,LPRINT,LBLK,LSTOP
      COMMON F(22,22,10),P(22,22),RHO(22,22),GAM(22,22),CON(22,22),
     &  AIP(22,22),AIM(22,22),AJP(22,22),AJM(22,22),AP(22,22),
     &  X(22),XU(22),XDIF(22),XCV(22),XCVS(22),
     &  Y(22),YV(22),YDIF(22),YCV(22),YCVS(22),
     &  YCVR(22),YCVRS(22),ARX(22),ARXJ(22),ARXJP(22),
     &  R(22),RMN(22),SX(22),SXMN(22),XCVI(22),XCVIP(22)
      COMMON DU(22,22),DV(22,22),FV(22),FVP(22),
     & FX(22),FXM(22),FY(22),FYM(22),PT(22),QT(22)
      COMMON /INDX/NF,NFMAX,NP,NRHO,NGAM,L1,L2,L3,M1,M2,M3,
     &  IST,JST,ITER,LAST,TITLE(13),RELAX(13),TIME,DT,XL,YL,
     &  IPREF,JPREF,LSOLVE(10),LPRINT(13),LBLK(10),MODE,NTIMES(10),RHOCO
     &N
      COMMON /CNTL/LSTOP
      COMMON /SORC/SMAX,SSUM
      COMMON /COEF/FLOW,DIFF,ACOF
      DIMENSION U(22,22),V(22,22),PC(22,22)
      EQUIVALENCE (F(1,1,1),U(1,1)),(F(1,1,2),V(1,1)),(F(1,1,3),PC(1,1))
*****************************************************************
*
*----------------- EXAMPLE SIX -----------------------------
*
*****************************************************************
      DIMENSION T(22,22)
      EQUIVALENCE (F(1,1,4),T(1,1))
*
      ENTRY GRID
      LAST=60
      DO 20 I=1,4
      LSOLVE(I)=.TRUE.
   20 LPRINT(I)=.TRUE.
      LPRINT(11)=.TRUE.
      LPRINT(12)=.TRUE.
      TITLE(1)='.VEL  U.'
      TITLE(2)='.VEL  V.'
      TITLE(3)='.STR FN.'
      TITLE(4)='. TEMP .'
      TITLE(11)='PRESSURE'
      TITLE(12)='DENSITY'
      RELAX(1)=0.5
      RELAX(2)=0.5
      RELAX(11)=0.8
      XL=0.5
      YL=2.
      L1=7
      M1=12
      CALL UGRID
      RETURN
*
      ENTRY START
      TIN=500
      TW=300.
      VIN=100.
      VOUT=VIN*XCV(L2)/X(L1)*TW/TIN
      DO 100 J=1,M1
      DO 100 I=1,L1
      U(I,J)=0
      V(I,J)=VOUT
      V(I,2)=0
      V(1,J)=0.
      T(I,J)=TW
  100 CONTINUE
      V(L2,2)=VIN
      T(L2,1)=TIN
      PR=.7
      AMU=1.
      AMUP=AMU/PR
      TREF=300.
      RHOREF=1.
      RHOT=RHOREF*TREF
      RETURN
*
      ENTRY DENSE
      DO 200 J=1,M1
      DO 200 I=1,L1
      RHO(I,J)=RHOT/T(I,J)
  200 CONTINUE
      RETURN
*
      ENTRY BOUND
      IF(ITER.NE.0) GOTO 300
      FLOWIN=RHO(L2,1)*V(L2,2)*XCV(L2)
  300 FL=0.
      DO 301 I=2,L2
  301 FL=FL+RHO(I,M1)*V(I,M2)*XCV(I)
      FACTOR=FLOWIN/FL
      DO 302 I=2,L2
      V(I,M1)=V(I,M2)*FACTOR
  302 T(I,M1)=T(I,M2)
      RETURN
*
      ENTRY OUTPUT
      IF(ITER.NE.0)  GOTO  400
      WRITE(8,401)
  401 FORMAT(1X,'   ITER',7X,'SMAX',11X,'SSUM',10X,'V(4,7)',
     &  9X,'T(4,7)')
  400 WRITE(8,403) ITER,SMAX,SSUM,V(4,7),T(4,7)
  403 FORMAT(1X,I6,1P4E15.3)
      IF (ITER.EQ.LAST) CALL PRINT
      RETURN
*
      ENTRY GAMSOR
      DO 500 J=1,M1
      DO 500 I=1,L1
      GAM(I,J)=AMU
      IF(NF.EQ.4) GAM(I,J)=AMUP
      IF(NF.NE.1) GAM(L1,J)=0.
      GAM(I,M1)=0.
  500 CONTINUE
      RETURN
      END
