******************************************************************
      SUBROUTINE USER
*****************************************************************
      DOUBLE PRECISION TITLE
      LOGICAL LSOLVE,LPRINT,LBLK,LSTOP
      COMMON F(22,22,10),P(22,22),RHO(22,22),GAM(22,22),CON(22,22),
     &  AIP(22,22),AIM(22,22),AJP(22,22),AJM(22,22),AP(22,22),
     &  X(22),XU(22),XDIF(22),XCV(22),XCVS(22),
     &  Y(22),YV(22),YDIF(22),YCV(22),YCVS(22),
     &  YCVR(22),YCVRS(22),ARX(22),ARXJ(22),ARXJP(22),
     &  R(22),RMN(22),SX(22),SXMN(22),XCVI(22),XCVIP(22)
      COMMON DU(22,22),DV(22,22),FV(22),FVP(22),
     & FX(22),FXM(22),FY(22),FYM(22),PT(22),QT(22)
      COMMON /INDX/NF,NFMAX,NP,NRHO,NGAM,L1,L2,L3,M1,M2,M3,
     &  IST,JST,ITER,LAST,TITLE(13),RELAX(13),TIME,DT,XL,YL,
     &  IPREF,JPREF,LSOLVE(10),LPRINT(13),LBLK(10),MODE,NTIMES(10),RHOCO
     &N
      COMMON /CNTL/LSTOP
      COMMON /SORC/SMAX,SSUM
      COMMON /COEF/FLOW,DIFF,ACOF
      DIMENSION U(22,22),V(22,22),PC(22,22)
      EQUIVALENCE (F(1,1,1),U(1,1)),(F(1,1,2),V(1,1)),(F(1,1,3),PC(1,1))
      DIMENSION TH(22),THU(22),THDIF(22),THCV(22),THCVS(22)
      EQUIVALENCE(X,TH),(XU,THU),(XDIF,THDIF),(XCV,THCV)
     &  ,(XCVS,THCVS),(XL,THL)
*****************************************************************
*
*----------------- EXAMPLE EIGHT -----------------------------
*
*****************************************************************
*
      ENTRY GRID
      DO 20 I=1,4
      LSOLVE(I)=.TRUE.
   20 LPRINT(I)=.TRUE.
      LPRINT(11)=.TRUE.
      TITLE(1)='.VEL  U.'
      TITLE(2)='.VEL  V.'
      TITLE(3)='.STR FN.'
      TITLE(11)='PRESSURE'
      RELAX(1)=0.5
      RELAX(2)=0.5
      RELAX(11)=0.8
      LAST=25
      MODE=2
      XL=0.5
      YL=0.5
      L1=7
      M1=7
      R(1)=0.
      CALL UGRID
      RETURN
*
      ENTRY START
      OMEGA=100.
      UIN=100.
      DO 100 J=1,M1
      DO 100 I=1,L1
      U(I,J)=0.
      V(I,J)=0.
      F(I,J,4)=0.
      F(L1,J,4)=R(J)**2*OMEGA
  100 CONTINUE
      U(2,2)=UIN
      AMU=1.
      RETURN
*
      ENTRY DENSE
      RETURN
*
      ENTRY BOUND
      IF(ITER.NE.0) GOTO 300
      FLOWIN=RHO(1,2)*U(2,2)*YCVR(2)
  300 FL=0.
      AR=0.
      DO 301 I=L3,L2
      FLT=R(M1)*XCV(I)*RHO(I,M1)
      AR=AR+FLT
  301 FL=FL+FLT*V(I,M2)
      ADD=(FLOWIN-FL)/AR
      DO 302 I=L3,L2
  302 V(I,M1)=V(I,M2)+ADD
      RETURN
*
      ENTRY OUTPUT
      IF(ITER.NE.0) GOTO 400
      WRITE(8,401)
  401 FORMAT(1X,'  ITER',7X,'SMAX',11X,'SSUM',10X,'U(4,4)',
     & 9X,'V(4,4)')
  400 WRITE(8,403) ITER,SMAX,SSUM,U(4,4),V(4,4)
  403 FORMAT(1X,I6,1P5E15.4)
      IF(ITER.EQ.LAST) CALL PRINT
      RETURN
*
      ENTRY GAMSOR
      IF(ITER.NE.0) GOTO 501
      DO 500 J=1,M1
      DO 500 I=1,L1
      GAM(I,J)=AMU
  500 CONTINUE
      GAM(L3,M1)=0.
      GAM(L2,M1)=0.
  501 CONTINUE
      IF(NF.NE.2) GOTO 510
      DO 502 J=3,M2
      DO 502 I=2,L2
      RSWM=FY(J)*F(I,J,4)+FYM(J)*F(I,J-1,4)
      RHOM=FY(J)*RHO(I,J)+FYM(J)*RHO(I,J-1)
      CON(I,J)=RHOM*RSWM**2/RMN(J)**3
  502 AP(I,J)=-AMU/RMN(J)**2
  510 IF(NF.NE.4) RETURN
      DO 512 J=2,M2
      DO 512 I=2,L2
      AR=2.*AMU/YCVR(J)
      CON(I,J)=AR*F(I,J-1,4)
  512 AP(I,J)=-AR
      RETURN
      END

